var permutable = (function (exports) {
  'use strict';

  var styles = "span,\ndiv,\ncanvas,\ntable,\nbutton,\ntbody,\ntr,\nth,\ntd {\n  background: unset;\n  border: unset;\n  box-sizing: border-box;\n  clear: unset;\n  color: unset;\n  cursor: unset;\n  filter: unset;\n  float: unset;\n  font: unset;\n  height: unset;\n  letter-spacing: unset;\n  line-height: unset;\n  margin: unset;\n  max-height: unset;\n  max-width: unset;\n  min-height: unset;\n  min-width: unset;\n  outline: unset;\n  overflow: unset;\n  padding: unset;\n  position: unset;\n  text-align: unset;\n  text-transform: unset;\n  transform: unset;\n  width: unset;\n  z-index: unset;\n}\n\nspan {\n  display: inline;\n}\n\ndiv,\ncanvas {\n  display: block;\n}\n\ntable {\n  display: table;\n  border-collapse: collapse;\n}\n\ntr {\n  display: table-row;\n}\n\nthead,\ntbody {\n  display: table-row-group;\n}\n\nth, td {\n  display: table-cell;\n}\n\n.permutable {\n  display: block;\n  width: 100%;\n  height: 100%;\n  font-family: \"Menlo\", \"Monaco\", monospace;\n  margin: 0;\n  color: #aaa;\n  user-select: none;\n  text-transform: uppercase;\n  font-size: 12px;\n  line-height: 1.2;\n  letter-spacing: 0.05em;\n  position: relative;\n}\n\nbutton {\n  cursor: pointer;\n  white-space: nowrap;\n  text-align: left;\n  background: #222;\n  color: #aaa;\n}\n\nbutton:hover {\n  background: #333;\n  color: white;\n}\n\nbutton:active {\n  background: #111;\n}\n\nbutton:disabled,\nbutton:disabled:hover {\n  cursor: default;\n  color: #444;\n  background: #222;\n  text-decoration: line-through;\n}\n\nbutton.active {\n  background: #ccc;\n  color: #222;\n\n  :hover {\n    background: white;\n    color: black;\n  }\n\n  :active {\n    background: #aaa;\n  }\n}\n\n.params .midi {\n  display: block;\n  margin: 0;\n  padding: 0 0.4rem;\n  line-height: inherit;\n}\n\n.param {\n  line-height: 1.8rem;\n}\n\n.file.param .flex {\n  padding: 0 0.5rem;\n  display: flex;\n  align-items: center;\n}\n\n.file.param .flex .name {\n  margin-right: 1em;\n}\n\n.file.param .flex input {\n  max-width: 20em;\n}\n\n.timer.param .name {\n  position: relative;\n  padding: 0 0.5rem;\n}\n\n.timer.param .value {\n  padding: 0 0.4rem;\n  position: relative;\n  width: 1%;\n  text-align: right;\n}\n\n.timer.param .value span {\n  display: inline-block;\n  animation: spin 1s linear infinite;\n}\n\n@keyframes spin {\n  from { transform: rotate(0); }\n  from { transform: rotate(-360deg); }\n}\n\n.bpm.param .name {\n  position: relative;\n  padding: 0 0.5rem;\n}\n\n.bpm.param .value {\n  position: relative;\n  padding: 0 0.4rem;\n  min-width: 3.5em;\n  text-align: right;\n}\n\n.bpm.param .buttons {\n  display: flex;\n  padding: 0;\n}\n\n.bpm.param .buttons button {\n  margin: 0;\n  padding: 0 0.4rem;\n  line-height: inherit;\n}\n\n.number.param .slider {\n  position: relative;\n  flex: auto;\n  cursor: ew-resize;\n  padding: 0 0.5rem;\n  background: rgba(255, 255, 255, 0.15);\n  border-left: 1px solid #ddd;\n}\n\n.number.param .indicator {\n  position: absolute;\n  top: 0;\n  left: 0;\n  bottom: 0;\n  background: white;\n  mix-blend-mode: difference;\n}\n\n.number.param .name {\n  position: relative;\n}\n\n.number.param .value {\n  position: relative;\n  padding: 0 0.4rem;\n  width: 1%;\n  text-align: right;\n}\n\n.number.param .input {\n  width: 1%;\n  padding: 0;\n}\n\n.toggle.param .name,\n.trigger.param .name {\n  position: relative;\n  padding: 0;\n}\n\n.toggle.param .button,\n.trigger.param .button {\n  display: block;\n  padding: 0 0.5rem;\n  width: 100%;\n}\n\n.toggle.param .value,\n.trigger.param .value {\n  position: relative;\n  padding: 0 0.4rem;\n  width: 1%;\n  text-align: right;\n}\n\n.toggle.param .input,\n.trigger.param .input {\n  width: 1%;\n  padding: 0;\n}\n\n.camera.param .name {\n  position: relative;\n  padding: 0 0.5rem;\n}\n\n.camera.param .video {\n  padding: 0 0.5rem;\n}\n\n.camera.param .video video {\n  width: 2em;\n  height: 2em;\n}\n\n.run .params {\n  position: absolute;\n  top: 0;\n  left: 0;\n  background: black;\n  width: 200px;\n  display: none;\n}\n\n.run .params.visible {\n  display: block;\n}\n\n.run canvas {\n  width: 100%;\n  height: 100%;\n}\n\n.mix {\n  display: flex;\n  min-height: 100%;\n  max-height: 100%;\n  border: 2px #aaa solid;\n  box-sizing: border-box;\n  -webkit-overflow-scrolling: touch;\n  background: black;\n  overflow: auto;\n}\n\n.mix .panel {\n  flex: 1;\n  display: flex;\n  flex-direction: column;\n  border-right: 2px #aaa solid;\n}\n\n.mix .panel:last-child {\n  border-right: 0;\n}\n\n.mix .panel .heading {\n  flex-grow: 0;\n  display: flex;\n  border-bottom: 2px #aaa solid;\n}\n\n.mix .panel .heading h2 {\n  flex: auto;\n  font-size: 1em;\n  font-weight: normal;\n  padding: 0.8rem;\n  margin: 0;\n}\n\n.mix .panel .heading button {\n  padding: 0 1rem;\n  border-left: 2px #aaa solid;\n}\n\n.mix .panel .content {\n  flex: 1;\n  overflow: auto;\n}\n\n.mix .panel.programs,\n.mix .panel.master {\n  flex: 0;\n}\n\n.mix .panel.programs button {\n  width: 100%;\n  padding: 0.8rem;\n  border-bottom: 2px #aaa solid;\n}\n\n.mix .panel.channels table {\n  width: 100%;\n  border-collapse: collapse;\n}\n\n.mix .panel.master canvas {\n  padding: 0.35rem;\n}\n\n.mix .panel.master .params {\n  border-collapse: collapse;\n  margin: 0 0.35rem;\n}\n\n.mix .channel {\n  border-bottom: 2px #aaa solid;\n}\n\n.mix .channel td {\n  vertical-align: top;\n}\n\n.mix .channel .title {\n  padding: 0.7rem;\n  width: 1%;\n}\n\n.mix .channel .params {\n  padding: 0.4rem;\n}\n\n.mix .channel .params.compose {\n  border-left: 2px #ccc solid;\n}\n\n.mix .channel .canvas {\n  position: relative;\n  width: 1%;\n  padding: 0.35rem;\n}\n\n.mix .channel .remove-button {\n  position: absolute;\n  top: 0.35rem;\n  right: 0.35rem;\n  width: 1.8rem;\n  height: 1.8rem;\n  text-align: center;\n}\n";

  class BPM extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key', 'value']
    }

    constructor () {
      super();

      this.taps = [];
      this.onTapClick = this.onTapClick.bind(this);
      this.onAddClick = this.onAddClick.bind(this);
      this.onSubtractClick = this.onSubtractClick.bind(this);
      this.value = 128;

      this.innerHTML = `
      <td class="name">Name</td>
      <td class="value">${this.value}</td>
      <td class="buttons">
        <button class="subtract">–</button>
        <button class="add">+</button>
        <button class="tap">Tap</button>
      </td>
    `;

      this.nameElement = this.querySelector('.name');
      this.valueElement = this.querySelector('.value');
      this.tapElement = this.querySelector('.tap');
      this.addElement = this.querySelector('.add');
      this.subtractElement = this.querySelector('.subtract');
    }

    get key () {
      return this.getAttribute('key')
    }

    get value () {
      const value = this.getAttribute('value');

      if (value) {
        return parseFloat(this.getAttribute('value'), 10)
      } else {
        return null
      }
    }

    get step () {
      return parseFloat(this.getAttribute('step'), 10) || 0.5
    }

    set value (value) {
      const stepped = Math.round(value / this.step) * this.step;
      this.setAttribute('value', stepped.toFixed(1));
      this.dispatchEvent(new CustomEvent('change', {
        bubbles: true
      }));
    }

    connectedCallback () {
      this.tapElement.addEventListener('mousedown', this.onTapClick);
      this.addElement.addEventListener('mousedown', this.onAddClick);
      this.subtractElement.addEventListener('mousedown', this.onSubtractClick);
    }

    disconnectedCallback () {
      this.tapElement.removeEventListener('mousedown', this.onTapClick);
      this.addElement.removeEventListener('mousedown', this.onAddClick);
      this.subtractElement.removeEventListener('mousedown', this.onSubtractClick);
    }

    onTapClick () {
      const current = performance.now();
      const previous = this.taps[0];
      const delta = current - previous;

      if (delta > 2000) {
        this.taps = [];
      }

      if (this.taps.length > 8) {
        this.taps.pop();
      }

      this.taps.unshift(current);

      const durations = Array(this.taps.length - 1).fill().map((v, i) => (
        this.taps[i] - this.taps[i + 1]
      ));

      if (durations.length) {
        const average = durations.reduce((a, b) => a + b, 0) / durations.length;
        const bpm = 60000 / average;
        this.value = bpm;
      }
    }

    onAddClick () {
      this.value += this.step;
    }

    onSubtractClick () {
      this.value -= this.step;
    }

    attributeChangedCallback (name, oldValue, newValue) {
      switch (name) {
        case 'key':
          return this.nameElement.innerText = this.getAttribute('key')
        case 'value':
          return this.valueElement.innerText = newValue || '-'
      }
    }
  }

  customElements.define('permutable-bpm-param', BPM, {
    extends: 'tr'
  });

  class Camera extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key']
    }

    constructor () {
      super();

      this.innerHTML = `
      <td class="name">Name</td>
      <td class="select"><select></select></td>
      <td class="video"><video></video></td>
    `;

      this.nameElement = this.querySelector('.name');
      this.valueElement = this.querySelector('.value');
      this.selectElement = this.querySelector('select');
      this.videoElement = this.querySelector('video');

      this.videoElement.addEventListener('loadedmetadata', () => {
        this.videoElement.play();
      });

      this.value = this.videoElement;

      this.selectElement.addEventListener('change', this.onSelectChange.bind(this));

      this.update = this.update.bind(this);
      this.onUserMedia = this.onUserMedia.bind(this);
      this.onUserMediaError = this.onUserMediaError.bind(this);

      navigator.mediaDevices.getUserMedia({ video: true })
        .then(this.onUserMedia)
        .catch(this.onUserMediaError);
    }

    onUserMedia (stream) {
      if (!this.stream) {
        navigator.mediaDevices.enumerateDevices()
          .then(this.onDevices.bind(this))
          .catch(this.onDevicesError.bind(this));
      }

      this.stream = stream;
      this.videoElement.srcObject = stream;

      this.selectElement.selectedIndex = [...this.selectElement.options].findIndex(option => {
        return option.text === stream.getVideoTracks()[0].label
      });

      this.start();
    }

    onUserMediaError (error) {
      console.warn('Could not get user media', error);
    }

    onDevices (devices) {
      this.selectElement.innerHTML = devices
        .filter(device => device.kind === 'videoinput')
        .map(device => `
        <option value="${device.deviceId}">
          ${device.label}
        </option>
      `);
    }

    onDevicesError (error) {
      console.warn('Could not get camera devices', error);
    }

    onSelectChange (event) {
      this.stop();

      const constraints = {
        audio: false,
        video: {
          deviceId: {
            exact: event.currentTarget.value
          }
        }
      };

      navigator.mediaDevices.getUserMedia(constraints)
        .then(this.onUserMedia)
        .catch(this.onUserMediaError);
    }

    start () {
      this.queueUpdate();
    }

    stop () {
      clearInterval(this.interval);
      window.cancelAnimationFrame(this.updateRequest);
      
      if (this.stream) {
        this.videoElement.pause();
        this.videoElement.srcObject = null;
        this.stream.getTracks().forEach(track => track.stop());
      }
    }

    update () {
      this.dispatchEvent(new CustomEvent('change', { bubbles: true }));
      this.queueUpdate();
    }

    queueUpdate () {
      this.updateRequest = window.requestAnimationFrame(this.update);
    }

    attributeChangedCallback (name, oldValue, newValue) {
      switch (name) {
        case 'key':
          return this.nameElement.innerText = this.getAttribute('key')
      }
    }
  }

  customElements.define('permutable-camera-param', Camera, {
    extends: 'tr'
  });

  class File extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key', 'accept', 'multiple']
    }

    constructor () {
      super();

      this.value = null;

      this.innerHTML = `
      <td colspan="3">
        <div class="flex">
          <span class="name">Name</span>
          <input type="file" />
        </div>
      </td>
    `;

      this.nameElement = this.querySelector('.name');
      this.fileElement = this.querySelector('input[type=file]');
      this.valueElement = this.querySelector('.value');

      this.fileElement.addEventListener('change', this.onChange.bind(this));
    }

    async onChange (event) {
      const passThrough = file => file;
      const process = this.props.process || passThrough;
      const files = Array.from(event.currentTarget.files);

      if (this.props.multiple) {
        this.value = await process(files);
      } else {
        this.value = await process(files[0]);
      }

      this.dispatchEvent(new CustomEvent('change', { bubbles: true }));
    }

    attributeChangedCallback (name, oldValue, newValue) {
      switch (name) {
        case 'key':
          return this.nameElement.innerText = this.getAttribute('key')
        case 'accept':
          return this.fileElement.setAttribute('accept', newValue)
        case 'multiple':
          if (newValue === 'true') {
            return this.fileElement.setAttribute('multiple', '')
          } else {
            return this.fileElement.removeAttribute('multiple')
          }
      }
    }
  }

  customElements.define('permutable-file-param', File, {
    extends: 'tr'
  });

  class Midi extends HTMLElement {
    static get observedAttributes() {
      return ['pairing', 'name', 'port']
    }

    constructor () {
      super();

      this.onKeyDown = this.onKeyDown.bind(this);
      this.onMidiMessage = this.onMidiMessage.bind(this);
      
      this.innerHTML = `<button class="midi">Midi</button>`;
      
      this.button = this.querySelector('button');
    }

    connectedCallback () {
      document.addEventListener('keydown', this.onKeyDown);

      this.addEventListener('click', this.onClick);

      try {
        navigator.requestMIDIAccess().then(access => {
          this.access = access;

          for (const input of this.access.inputs.values()) {
            input.addEventListener('midimessage', this.onMidiMessage);
          }
        });
      } catch (error) {
        console.warn(`MIDI not available (${error.message}). See https://caniuse.com/#feat=midi for browser support tables`);
        this.button.disabled = true;
        this.button.title = 'Midi not available (see console for more info)';
      }
    }

    disconnectedCallback () {
      document.removeEventListener('keydown', this.onKeyDown);

      this.removeEventListener('click', this.onClick);

      if (this.access) {
        for (const input of this.access.inputs.values()) {
          input.removeEventListener('midimessage', this.onMidiMessage);
        }
      }
    }

    onClick () {
      if (this.toggleAttribute('pairing')) {
        for (const input of this.access.inputs.values()) {
          console.log('Available for pairing:', input.name);
        }
      }
    }

    onKeyDown (event) {
      if ([46, 8].includes(event.keyCode) && this.hasAttribute('pairing')) {
        event.preventDefault();
        this.removeAttribute('id');
        this.removeAttribute('name');
        this.removeAttribute('port');
        this.removeAttribute('pairing');
      }
    }

    onMidiMessage (event) {
      const { id, name } = event.currentTarget;
      const [type, port, value] = event.data;

      if (this.hasAttribute('pairing')) {
        this.setAttribute('id', id);
        this.setAttribute('name', name);
        this.setAttribute('port', port);
        this.removeAttribute('pairing');
      }

      if (this.getAttribute('id') == id && this.getAttribute('port') == port) {
        const normalValue = value / 127;

        this.dispatchEvent(new CustomEvent('input', {
          detail: {
            type: type,
            port: port,
            value: normalValue
          }
        }));
      }
    }

    attributeChangedCallback () {
      const pairing = this.hasAttribute('pairing');
      const name = this.getAttribute('name');
      const port = this.getAttribute('port');

      this.button.classList.toggle('active', pairing);
      this.button.innerText = name && port ? `${name.split(' ')[0]}#${port}` : 'Midi';
    }
  }

  customElements.define('permutable-midi-input', Midi);

  class Number extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key', 'value', 'min', 'max', 'step']
    }

    constructor () {
      super();

      this.setAttribute('min', 0);
      this.setAttribute('max', 1);
      this.setAttribute('step', 0.01);
      this.setAttribute('value', 0);

      this.onMidiInput = this.onMidiInput.bind(this);
      this.onMouseDown = this.onMouseDown.bind(this);

      this.innerHTML = `
      <td class="slider">
        <div class="name"></div>
        <div class="indicator"></div>
      </td>
      <td class="value"></td>
      <td class="input">
        <permutable-midi-input />
      </td>
    `;

      this.sliderElement = this.querySelector('.slider');
      this.nameElement = this.querySelector('.name');
      this.indicatorElement = this.querySelector('.indicator');
      this.valueElement = this.querySelector('.value');
      this.midiInput = this.querySelector('permutable-midi-input');
    }

    connectedCallback () {
      this.midiInput.addEventListener('input', this.onMidiInput);
      this.sliderElement.addEventListener('mousedown', this.onMouseDown);
    }

    disconnectedCallback () {
      this.midiInput.removeEventListener('input', this.onMidiInput);
      this.sliderElement.removeEventListener('mousedown', this.onMouseDown);
    }

    get min () {
      return parseFloat(this.getAttribute('min'), 10)
    }

    get max () {
      return parseFloat(this.getAttribute('max'), 10)
    }

    get step () {
      return parseFloat(this.getAttribute('step'), 10)
    }

    get value () {
      return parseFloat(this.getAttribute('value'), 10)
    }

    set value (value) {
      this.setAttribute('value', value);
      this.dispatchEvent(new CustomEvent('change', {
        bubbles: true
      }));
    }

    set normalValue (normalValue) {
      const stepped = this.min + Math.round((normalValue * this.range) / this.step) * this.step;
      const clamped = Math.max(this.min, Math.min(this.max, stepped));
      this.value = clamped;
    }

    get range () {
      return this.max - this.min
    }

    onMouseDown (event) {
      const onDrag = event => {
        const rect = this.sliderElement.getBoundingClientRect();
        const position = (event.clientX - Math.floor(rect.left)) / Math.floor(rect.width);
        this.normalValue = position;
      };

      const onEnd = () => {
        document.removeEventListener('mousemove', onDrag);
        document.removeEventListener('mouseup', onEnd);
      };

      onDrag(event);

      document.addEventListener('mousemove', onDrag);
      document.addEventListener('mouseup', onEnd);
    }

    onMidiInput (event) {
      this.normalValue = event.detail.value;
    }

    attributeChangedCallback (name) {
      const percent = ((this.value - this.min) / this.range) * 100;
      const decimals = (this.step.toString().split('.')[1] || '').length;
      const displayValue = this.value.toFixed(decimals);

      if (this.indicatorElement) {
        this.indicatorElement.style.width = `${percent}%`;
        this.nameElement.innerText = this.getAttribute('key');
        this.valueElement.innerText = displayValue;
      }
    }
  }

  customElements.define('permutable-number-param', Number, {
    extends: 'tr'
  });

  class Timer extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key']
    }

    constructor () {
      super();

      this.value = 0;

      this.update = this.update.bind(this);

      this.innerHTML = `
      <td class="name">Name</td>
      <td class="value"><span>-</span></td>
    `;

      this.nameElement = this.querySelector('.name');
      this.valueElement = this.querySelector('.value');
    }

    connectedCallback () {
      this.queueUpdate();
    }

    disconnectedCallback () {
      clearInterval(this.interval);
      window.cancelAnimationFrame(this.updateRequest);
    }

    update (time) {
      this.value = parseFloat((time / 1000).toFixed(2), 10);
      this.dispatchEvent(new CustomEvent('change', { bubbles: true }));
      this.queueUpdate();
    }

    queueUpdate () {
      this.updateRequest = window.requestAnimationFrame(this.update);
    }

    attributeChangedCallback (name, oldValue, newValue) {
      switch (name) {
        case 'key':
          return this.nameElement.innerText = this.getAttribute('key')
      }
    }
  }

  customElements.define('permutable-timer-param', Timer, {
    extends: 'tr'
  });

  class Toggle extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key', 'active']
    }

    constructor () {
      super();

      this.onClick = this.onClick.bind(this);
      this.onMidiInput = this.onMidiInput.bind(this);

      this.innerHTML = `
      <td class="name">
        <button class="button"></button>
      </td>
      <td class="value"></td>
      <td class="input">
        <permutable-midi-input />
      </td>
    `;

      this.button = this.querySelector('button');
      this.nameElement = this.querySelector('.name');
      this.valueElement = this.querySelector('.value');
      this.midiInput = this.querySelector('permutable-midi-input');
    }

    connectedCallback () {
      this.nameElement.addEventListener('click', this.onClick);
      this.midiInput.addEventListener('input', this.onMidiInput);
    }

    disconnectedCallback () {
      this.nameElement.removeEventListener('click', this.onClick);
      this.midiInput.removeEventListener('input', this.onMidiInput);
    }

    set value (value) {
      this.setAttribute('active', value);
      this.dispatchEvent(new CustomEvent('change', {
        bubbles: true
      }));
    }

    get value () {
      return this.getAttribute('active') === 'true'
    }

    onClick (event) {
      this.value = !this.value;
    }

    onMidiInput (event) {
      const { type, value } = event.detail;

      if (type === 144) {
        this.value = !this.value;
      } else if (type !== 128) {
        this.value = value > 0.5;
      }
    }

    attributeChangedCallback (name, oldValue, newValue) {
      this.button.innerText = this.getAttribute('key');
      this.valueElement.innerText = this.value ? 'On' : 'Off';
    }
  }

  customElements.define('permutable-toggle-param', Toggle, {
    extends: 'tr'
  });

  class Trigger extends HTMLTableRowElement {
    static get observedAttributes() {
      return ['key', 'active']
    }

    constructor () {
      super();

      this.onMouseDown = this.onMouseDown.bind(this);
      this.onMouseUp = this.onMouseUp.bind(this);
      this.onMidiInput = this.onMidiInput.bind(this);

      this.innerHTML = `
      <td class="name">
        <button class="button"></button>
      </td>
      <td class="value"></td>
      <td class="input">
        <permutable-midi-input />
      </td>
    `;

      this.button = this.querySelector('button');
      this.nameElement = this.querySelector('.name');
      this.valueElement = this.querySelector('.value');
      this.midiInput = this.querySelector('permutable-midi-input');

      this.update();
    }

    connectedCallback () {
      this.button.addEventListener('mousedown', this.onMouseDown);
      this.button.addEventListener('mouseup', this.onMouseUp);
      this.midiInput.addEventListener('input', this.onMidiInput);
    }

    disconnectedCallback () {
      this.button.removeEventListener('mousedown', this.onMouseDown);
      this.button.removeEventListener('mouseup', this.onMouseUp);
      this.midiInput.removeEventListener('input', this.onMidiInput);
    }

    set value (value) {
      this.toggleAttribute('active', value);
      this.dispatchEvent(new CustomEvent('change', {
        bubbles: true
      }));
    }

    get value () {
      return this.hasAttribute('active')
    }

    onMouseDown (event) {
      this.value = true;
    }

    onMouseUp (event) {
      this.value = false;
    }

    onMidiInput (event) {
      const { type, value } = event.detail;

      if (type === 144) {
        this.value = true;
      } else if (type === 128) {
        this.value = false;
      }
    }

    attributeChangedCallback () {
      this.update();
    }

    update () {
      this.button.innerText = this.getAttribute('key');
      this.valueElement.innerText = this.value ? 'On' : 'Off';
    }
  }

  customElements.define('permutable-trigger-param', Trigger, {
    extends: 'tr'
  });

  class Params {
    constructor (description) {
      this.element = document.createElement('tbody');

      for (let key in description) {
        const { type, ...props } = description[key];

        const element = document.createElement('tr', {
          is: `permutable-${type}-param`
        });

        element.props = props;
        element.classList.add(type, 'param');
        element.setAttribute('key', key);

        for (let prop in props) {
          element.setAttribute(prop, props[prop]);
        }

        this.element.appendChild(element);
      }
    }

    remove () {
      this.element.remove();
    }

    get values () {
      const values = {};

      for (let element of this.element.childNodes) {
        values[element.getAttribute('key')] = element.value;
      }

      return values
    }
  }

  class Program {
    constructor (description = {}, {
      autoRender = true
    } = {}) {
      if (!description.name) {
        throw new Error('Program should have a name')
      }

      this.name = description.name;
      this.setupHandler = description.setup;
      this.autoRender = autoRender;
      this.dirty = true;

      this.render = this.render.bind(this);
      this.queueRender = this.queueRender.bind(this);
      this.onChange = this.onChange.bind(this);

      this.canvasElement = document.createElement('canvas');
      this.params = new Params(description.params);

      this.params.element.addEventListener('change', this.onChange);
    }

    setup () {
      Promise.resolve(this.setupHandler(this.canvasElement)).then(renderHandler => {
        this.renderHandler = renderHandler;

        if (this.autoRender) {
          this.queueRender();
        }
      });
    }

    remove () {
      this.params.element.removeEventListener('change', this.queueRender);
      this.params.remove();
      this.canvasElement.remove();
    }

    render () {
      this.dirty = false;
      this.renderRequest = null;

      if (this.renderHandler) {
        this.renderHandler(this.params.values);
      }
    }

    onChange () {
      this.dirty = true;

      if (this.autoRender) {
        this.queueRender();
      }
    }

    queueRender () {
      if (!this.renderRequest) {
        this.renderRequest = window.requestAnimationFrame(this.render);
      }
    }
  }

  class Channel {
    constructor (program, params) {
      this.program = program;

      this.element = document.createElement('tr');
      this.element.classList.add('channel');

      this.params = new Params(params);

      this.element.innerHTML = `
      <td class="title">${program.name}</td>
      <td class="params">
        <table data-program-params></table>
      </td>
      <td data-canvas class="canvas">
        <button data-remove class="remove-button">
          ×
        </button>
      </td>
      <td class="compose params">
        <table data-channel-params></table>
      </td>
    `;

      this.remove = this.remove.bind(this);
      this.removeButton = this.element.querySelector('[data-remove]');
      this.removeButton.addEventListener('click', this.remove);

      this.programParamsCell = this.element.querySelector('[data-program-params]');
      this.programParamsCell.appendChild(program.params.element);

      this.paramsCell = this.element.querySelector('[data-channel-params]');
      this.paramsCell.appendChild(this.params.element);

      this.canvasContainer = this.element.querySelector('[data-canvas]');
      this.canvasContainer.appendChild(program.canvasElement);
    }

    remove () {
      this.element.dispatchEvent(new CustomEvent('remove'));
      this.removeButton.removeEventListener('click', this.remove);
      this.program.remove();
      this.element.remove();
    }
  }

  var defaultCompositor = {
    channelParams: {
      mix: {
        type: 'number'
      }
    },

    params: {
      brightness: {
        type: 'number',
        value: 1
      }
    },

    setup (canvas) {
      const context = canvas.getContext('2d');

      return function render (channels, values) {
        const { width, height } = canvas;

        context.globalCompositeOperation = 'source-over';
        context.globalAlpha = 1;
        context.fillRect(0, 0, canvas.width, canvas.height);

        context.globalCompositeOperation = 'screen';

        channels.forEach(channel => {
          context.globalAlpha = channel.params.values.mix;
          context.drawImage(channel.program.canvasElement, 0, 0);
        });

        const { brightness } = values;

        if (brightness < 1) {
          context.globalCompositeOperation = 'source-over';
          context.globalAlpha = 1 - brightness;
          context.fillRect(0, 0, width, height);
        }
      }
    }
  };

  var index = (
    descriptions,
    {
      container = document.body,
      width = 1280,
      height = 720,
      ratio = 1,
      compositor = defaultCompositor
    } = {}
  ) => {
    container.innerHTML = `
    <style scoped>
      ${styles}
    </style>

    <div class="permutable mix">
      <div class="programs panel"}>
        <div class="heading">
          <h2>Programs</h2>
        </div>

        <div class="content" data-programs></div>
      </div>

      <div class="channels panel">
        <div class="heading">
          <h2>Channels</h2>
        </div>

        <div class="content">
          <table data-channels></table>
        </div>
      </div>

      <div class="master panel">
        <div class="heading">
          <h2>Master</h2>
          <button data-open-output>
            Open output window
          </button>
        </div>

        <div class="canvas">
          <canvas data-canvas />
        </div>

        <table class="params" data-master-params></table>
      </div>
    </div>
  `;

    const canvas = container.querySelector('[data-canvas]');
    const compose = compositor.setup(canvas);

    canvas.width = width * ratio;
    canvas.height = height * ratio;

    const channels = [];
    const outputs = [];

    const masterParams = new Params(compositor.params);

    const programList = container.querySelector('[data-programs]');
    const channelList = container.querySelector('[data-channels]');
    const outputButton = container.querySelector('[data-open-output]');
    const masterParamsContainer = container.querySelector('[data-master-params]');

    masterParamsContainer.appendChild(masterParams.element);
    masterParamsContainer.addEventListener('change', queueRender);

    outputButton.addEventListener('click', event => {
      const name = `Output ${outputs.length + 1}`;
      const options = `location=0,width=${width},height=${height}`;
      const win = window.open('', name, options);
      const canvas = document.createElement('canvas');
      const context = canvas.getContext('2d');
      const output = { canvas, context };

      canvas.width = width;
      canvas.height = height;
      canvas.style.width = '100vw';
      canvas.style.height = '100vh';

      const setup = () => {
        const { body } = win.document;
        win.document.title = name;
        body.style.margin = 0;
        body.style.background = 'black';
        body.appendChild(canvas);
      };

      if ('document' in win) {
        setup();
      } else {
        win.addEventListener('load', () => setup);
      }

      win.addEventListener('beforeunload', () => {
        outputs.splice(outputs.indexOf(output), 1);
      });

      outputs.push(output);

      queueRender();
    });

    descriptions.forEach(description => {
      if (!description.params) {
        description.params = {};
      }

      const button = document.createElement('button');

      button.classList.add(styles.programButton);
      button.innerText = description.name;

      button.addEventListener('click', () => {
        const program = new Program(description, { autoRender: false });
        const channel = new Channel(program, compositor.channelParams);

        program.canvasElement.width = canvas.width;
        program.canvasElement.height = canvas.height;
        program.canvasElement.style.width = canvas.width / 8;
        program.setup();

        channels.push(channel);
        channelList.appendChild(channel.element);

        channel.element.addEventListener('change', queueRender);
        channel.element.addEventListener('remove', function onRemove () {
          channels.splice(channels.indexOf(channel), 1);
          channel.element.removeEventListener('change', queueRender);
          channel.element.removeEventListener('remove', onRemove);
          queueRender();
        });

        queueLayout();
        queueRender();
      });

      programList.appendChild(button);
    });

    let renderRequest;

    function render () {
      channels.forEach(channel => {
        if (channel.program.dirty) {
          channel.program.render();
        }
      });

      compose(channels, masterParams.values);

      outputs.forEach(output => {
        output.context.drawImage(canvas, 0, 0);
      });

      renderRequest = null;
    }

    function queueRender () {
      if (!renderRequest) {
        renderRequest = window.requestAnimationFrame(render);
      }
    }

    let layoutRequest;

    function layout () {
      const targets = [{
        canvas: canvas,
        ratio: 3
      }, ...channels.map(channel => ({
        canvas: channel.program.canvasElement,
        ratio: 6
      }))];

      targets.forEach(target => {
        let displayWidth = target.canvas.width;

        while (displayWidth > window.innerWidth / target.ratio) {
          displayWidth = displayWidth / 2;
        }

        target.canvas.style.width = displayWidth;
      });

      layoutRequest = null;

      queueRender();
    }

    function queueLayout () {
      if (!layoutRequest) {
        layoutRequest = window.requestAnimationFrame(layout);
      }
    }

    queueLayout();

    window.addEventListener('resize', queueLayout);
  };

  function run (
    description,
    {
      container = document.body,
      width = null,
      height = null,
      ratio = window.devicePixelRatio,
      visible = true
    } = {}
  ) {
    const program = new Program(description.default || description);
    const element = document.createElement('div');

    element.classList.add('permutable', 'run');

    const styleElement = document.createElement('style');

    styleElement.setAttribute('scoped', true);
    styleElement.innerHTML = styles;

    container.appendChild(styleElement);

    const paramsTable = document.createElement('table');

    paramsTable.classList.add('params');
    paramsTable.appendChild(program.params.element);

    element.appendChild(program.canvasElement);
    element.appendChild(paramsTable);

    container.appendChild(element);

    if (width || height) {
      container.style.width = width;
      container.style.height = height;
      program.canvasElement.width = width * ratio;
      program.canvasElement.height = height * ratio;
    } else {
      async function resize () {
        const width = container.offsetWidth;
        const height = container.offsetHeight;
        program.canvasElement.width = width * ratio;
        program.canvasElement.height = height * ratio;
      }

      window.addEventListener('resize', () => {
        resize().then(program.render);
      });

      resize();
    }

    window.addEventListener('keydown', event => {
      if (event.keyCode === 27) {
        paramsTable.classList.toggle('visible');
      }
    });

    paramsTable.classList.toggle('visible', visible);

    program.setup();

    return {
      _program: program
    }
  }

  exports.mix = index;
  exports.run = run;

  return exports;

}({}));
